"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var ReactHardwareEmptyComponent = function ReactHardwareEmptyComponent() {
  // ReactCompositeComponent uses this:
  this._currentElement = null;

  // ReactHardwareComponent uses these
  this._rootNodeID = null;
  this._renderedChildren = null;
  this._io = null;
};

Object.assign(ReactHardwareEmptyComponent.prototype, {
  construct: function construct(element) {},
  mountComponent: function mountComponent(transaction, nativeParent, nativeContainerInfo, context) {
    if (nativeContainerInfo) {
      var id = nativeContainerInfo._idCounter++;
      this._id = id;
    }
  },
  receiveComponent: function receiveComponent() {},
  getNativeNode: function getNativeNode() {
    // TODO?
    return this;
  },
  unmountComponent: function unmountComponent() {}
});

exports.default = ReactHardwareEmptyComponent;